#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "commonTypes.h"
#include "ringbuffer.h"



typedef struct {
    bool stopSignal;
} mariadbsinkThreadContext_t;

void mariadbsinkStop(void *ptr) {
    commonThreadHandle_t *handle = (commonThreadHandle_t*)ptr;
    mariadbsinkThreadContext_t *context = (mariadbsinkThreadContext_t*)handle->sinkContext;

    context->stopSignal = true;
    fprintf(stderr, "mariadb sink thread, stop flagged\n");
}


void *mariadbsink(void *ptr) {
    fprintf(stderr, "mariadb sink entered\n");

    commonThreadHandle_t *handle = (commonThreadHandle_t*)ptr;
    mariadbsinkThreadContext_t *context = (mariadbsinkThreadContext_t*) malloc(sizeof(mariadbsinkThreadContext_t));
    handle->sinkContext = (void*)context;
    context->stopSignal = false;

    while (! context->stopSignal) {
        auditItem_t *auditItem = (auditItem_t*)ringbufferGet(handle->ringbuffer);

        if (auditItem != NULL) {
            printf("AuditItem: Time:    %ld\n", auditItem->ts);
            printf("AuditItem: Topic:   %s\n", auditItem->topic);
            printf("AuditItem: Payload: %s\n", auditItem->payload);

            free(auditItem->topic);
            auditItem->topic = NULL;
            free(auditItem->payload);
            auditItem->payload = NULL;
            free(auditItem);
            auditItem = NULL;
        }
    }

    fprintf(stderr, "mariadb sink thread stopped\n");
    return (void*)NULL;
}

